package hm;

import robocode.*;
import robocode.util.*;
import java.util.*;

//import java.awt.Color;

// API help : http://robocode.sourceforge.net/docs/robocode/robocode/Robot.html



/**
 * Pomeroni - a robot by (your name here)
 */
public class Pomeroni extends AdvancedRobot
{
	int follow;
	String name_follow;
	double MIN_FOLLOW_DISTANCE = 1000;
	double MAX_FIRE_DISTANCE = 700;
	double MIN_FOLLOW_TIME = 4;
	double MIN_DISTANCE = 200; // min robo distance
	double MAX_DISTANCE_AVOID_BULLET = 500; // if robot is closer than this and it shoots, try to avoid the bullet
			// in duel we allways try to avoid
	double last_follow=0;
	int wallMargin=40;
	int direction=1;
	int duel=0;	//0: normal mode, 1: duel mode 
	Vector robots;
	double FOLLOW_BLOCK_TIME = 20.0;	// how long we wait at least before changing 
		//the enemy we are following, prevents us from changing the enemy too quickly

	double WALLHIT_CHECK_DISTANCE = 40;	// if we are closer to the edge than this, we do more
		// detailed wallhit-analysis
	double WAY_TOO_CLOSE_DISTANCE = 20;
	
	
	/**
	 * run: Pomeroni's default behavior
	 */
	public void run() {
		out.println("Hello, INSTANSSI 2013!\nThis is Pomeroni v2.0-build1217\n............................................\nCredits: #instanssi #isobaari JYFL Logio Gagis Sahra");
		robots = new Vector();
		
		follow=0; name_follow="";

		
		//setColors(Color.red,Color.blue,Color.green); // body,gun,radar
			setAdjustRadarForRobotTurn(true);
			setAdjustGunForRobotTurn(true);
		// Robot main loop
		while(true) {
			// always rotate the radar
			setTurnRadarLeft(50000);
			CheckBadMovement();
			waitFor(new TurnCompleteCondition(this));
		}
	}

	/**
	 * onScannedRobot: What to do when you see another robot
	 */
	public void onScannedRobot(ScannedRobotEvent e) {
		
		// Update our enemy table
		int found=0;
		double absolute_angle = getHeadingRadians() + e.getBearingRadians();
		Robot enemy = new Robot();
		if (robots.size()==1)
			duel=1;
		for (int i=0; i<robots.size(); i++)
		{
			if (e.getName()==((Robot)robots.elementAt(i)).GetName())
			{
				found=1;
				((Robot)robots.elementAt(i)).SetTime(e.getTime());
				
				((Robot)robots.elementAt(i)).SetX(getX()+e.getDistance()*Math.sin(absolute_angle));
				((Robot)robots.elementAt(i)).SetY(getY()-e.getDistance()*Math.cos(absolute_angle));
				enemy = (Robot)(robots.elementAt(i));
				
				if (enemy.FollowBlocked()>0)
				{
					if (getTime()-enemy.FollowBlocked()>20)
					{
						enemy.RemoveFollowBlocked();
						out.println("Removing follow block for "+ enemy.GetName());
					}
				}
				
				// Try to quess if the enemy just tried to shoot us
				double delta_hp = ((Robot)robots.elementAt(i)).GetHP() - e.getEnergy();

				if (delta_hp > 0 && delta_hp <= 3)
				{
					if (duel==1 || e.getDistance()<MAX_DISTANCE_AVOID_BULLET)
					{
						PanicAvoidBullet((Robot)robots.elementAt(i));
					}
				}
				((Robot)robots.elementAt(i)).SetHP(e.getEnergy());
				
				
			}
		}
		if (found==0)
		{
			Robot nrobo = new Robot();
			nrobo.SetName(e.getName());
			nrobo.SetTime(e.getTime());
			nrobo.SetX(getX()+e.getDistance()*Math.sin(absolute_angle));
			nrobo.SetY(getY()+e.getDistance()*Math.cos(absolute_angle));
			out.println("New robot " + e.getName() + " at " + nrobo.GetX() + " , " + nrobo.GetY()
				+ " own position " + getX() + ", " + getY() );
			robots.addElement(nrobo);	
			enemy=nrobo;
			
			if (robots.size()>1) duel=0;
		}
		
		
		//out.println("ScanEvent " + e.getName());
		// Not one-one-one fight
		if (duel==0)
		{
			// Is this one closest
			int closest=1;
			for (ScannedRobotEvent event : getScannedRobotEvents()) {
	 			if (e.getDistance() > event.getDistance()*1.01)
					closest=0;
	   		}
			if (closest==0) return;
			
			if (enemy.FollowBlocked()>0) return;
			if (e.getDistance()>MIN_FOLLOW_DISTANCE )
				return;
			if (getTime()-last_follow < MIN_FOLLOW_TIME && e.getName() != name_follow)
			{
				if (e.getDistance() > WAY_TOO_CLOSE_DISTANCE)
				//out.println("Don't do anything, name " + e.getName() + " timediff " + (getTime()-last_follow) + " following " + name_follow);
					return;
			}
		}
		
		// Velocity vector for the tank we see
		double v_x, v_y, v;
		v = Math.abs(e.getVelocity());
		v_x = v*Math.cos(absolute_angle);
		v_y = v*Math.sin(absolute_angle);
		
		// Separation between my tank and the tank we see
		double dist_x, dist_y;
		dist_x = e.getDistance() * Math.sin(absolute_angle);
		dist_y = e.getDistance() * Math.cos(absolute_angle);
		
		double power = 1;
		
		if (e.getDistance()<200)
			power=3;
		else if (e.getDistance()<350)
			power=2.5;
		else if (e.getDistance()<500)
			power=2;
		//power = 400 / e.getDistance();

		
		double enemy_absolute_bearing = e.getBearingRadians() + getHeadingRadians();
		
		// Joo, oli hieno idea laskea vihellosin transversiaalinen nopeus omaan nähden ja arvioida siitä
		// osumatodennäköisyyttä (iso nopeus, luultavasti mokataan). Mutta näyttää siltä että robo pärjää
		// huonommin tämän kanssa joten kommentoidaanpa pois....
		double enemy_perp_vel = e.getVelocity()*Math.sin(e.getHeadingRadians() - enemy_absolute_bearing);
			
					
		/*if (power>1 && Math.abs(enemy_perp_vel) < 2)
			power += 1;
		if (Math.abs(enemy_perp_vel) < 1 && e.getDistance()<150)
			power+=1;*/
		
		/*if (power>1 && enemy_perp_vel>3)
		{	power=power-1;
			out.println("Enemy is moving so fast that let's reduce the ammo power! velocity " + enemy_perp_vel);
		}*/
		
		double ammo_vel = 20.0-3.0*power;
		double time = e.getDistance()/ammo_vel;
		
		
		double turn = enemy_absolute_bearing - getHeadingRadians() + Math.asin( enemy_perp_vel / ammo_vel );
		
		double absoluteBearing = getHeadingRadians() + e.getBearingRadians();

		
		turn = Utils.normalRelativeAngle(turn);
		
		setTurnGunRightRadians(Utils.normalRelativeAngle(absoluteBearing - 
  		  	getGunHeadingRadians() + (e.getVelocity() * Math.sin(e.getHeadingRadians() - 
   			absoluteBearing) / ammo_vel)));
		
		double mindist = MIN_DISTANCE;
		if (duel==1) mindist=mindist*1.2;
		if (e.getDistance()<mindist )
		{
			out.println("Tooclose, dist " + e.getDistance());
			//setTurnRight(RadToDeg(turn)+20);
			setAhead(e.getDistance()-mindist);
			setTurnRight(20*Math.sin(getTime()));
			
			if (Math.abs(getGunTurnRemaining()) < 10 )
			{
				out.println("Close-range shoot!");
			
				setFire(2.5);
			}
			// We are too close
			//fire(power);
			//enemy.SetFollowBlocked(getTime());
			//out.println("Follow block: " + enemy.GetName());
		}
		else
		{
			setTurnRight(RadToDeg(turn) + 20*Math.sin(getTime()/1.0));
			double move = e.getDistance()-MIN_DISTANCE;
			//move=5;
			if (move<0) 
				out.println("WTF, negative movement????");
			setAhead(direction*move);
			
		}
		waitFor(new GunTurnCompleteCondition(this));
		//waitFor(new TurnCompleteCondition(this));
		//out.println("Käänny " + turn + " dist " + e.getDistance()+ " follow " + e.getName());
		
		if (e.getDistance() < MAX_FIRE_DISTANCE /*&& Math.abs(getGunTurnRemaining()) < 10 && getGunHeat()==0*/)
		{
				//out.println("Fire! power " + power + " dist " + e.getDistance() + " target " + e.getName());
				setFire(power);

		}
		last_follow = getTime();
		name_follow = e.getName();
		
		

		
		
	}
	
	// Check that we are not doing something stupid, namely hitting the wall
	public void CheckBadMovement()
	{
		// First, only check for possible wall-hit if we are close to an edge
		double x = getX(); double y=getY();
		if (x<WALLHIT_CHECK_DISTANCE || y< WALLHIT_CHECK_DISTANCE 
				|| getBattleFieldWidth()-x <  WALLHIT_CHECK_DISTANCE || getBattleFieldHeight()-y <  WALLHIT_CHECK_DISTANCE)
		{
			double angle = getHeadingRadians();
			double dist = getDistanceRemaining();
			double dx = dist * Math.sin(angle);
			double dy = dist * Math.cos(angle);
			
			double newx = getX() + dx;
			double newy = getY() + dy;
		
			if (newx<WALLHIT_CHECK_DISTANCE/1.0 || newy< WALLHIT_CHECK_DISTANCE/1.0 
					|| getBattleFieldWidth()-newx <  WALLHIT_CHECK_DISTANCE/1.0 || getBattleFieldHeight()-newy <  WALLHIT_CHECK_DISTANCE/1.0)
			{
				out.println("Collision........");
				setTurnLeft(30);
				setAhead(-40);
			}
			
		}
			
		                      
	}
	
	// Enemy robo is most likely shooting at us, try to avoid the bullet
	public void PanicAvoidBullet(Robot robo)
	{	
		if (duel==1)
		{
			out.println("Avoid robo " + robo.GetName());
			setTurnRight(30);
			setAhead(20);
		}
	}

	/**
	 * onHitByBullet: What to do when you're hit by a bullet
	 */
	public void onHitByBullet(HitByBulletEvent e) {
		// Replace the next line with any behavior you would like
		//setTurnRight(30);
		//setTurnRadarLeft(50);
		//setAhead(50);
	}
	
	/**
	 * onHitWall: What to do when you hit a wall
	 */
	public void onHitWall(HitWallEvent e) {
		// Replace the next line with any behavior you would like
		out.println("Wallhit (why????)");
		setBack(30);
		setTurnLeft(90);
	}	

	public double DegToRad(double deg)
	{
		return deg/360.0*2.0*3.1415192;
	}
	public double RadToDeg(double rad)
	{
		return rad/(2.0*3.14159265) * 360.0;
	}

	public void onHitRobot(HitRobotEvent e) {
		
		double enemy_absolute_bearing = e.getBearingRadians() + getHeadingRadians();
					

		
		/*
		double turn = Utils.normalRelativeAngle(enemy_absolute_bearing - 
  		  	getGunHeadingRadians() );
		if (Math.abs(turn)<0.2 || Math.abs(turn-2.0*3.141592) < 0.2)
		{
			out.println("Hit, FIRE!! turn " + turn );
			fire(2);
		}*/
		
		// If we're moving the other robot, reverse!
		/*if (e.isMyFault()) {
			setTurnLeft(20);
			setBack(40);
			return;
		}*/
	}

	public void onSkippedTurn(SkippedTurnEvent e)
	{
		out.println("Skipped turn :o");
	}
	
	public void onRobotDeath(RobotDeathEvent e)
	{
		for (int i=0; i<robots.size(); i++)
		{
			if (e.getName()==((Robot)robots.elementAt(i)).GetName())
			{
				robots.remove(i);
				out.println("Robot "+ e.getName() +" died");
			}
		}
		if (robots.size()==1)
			duel=1;
	}

public void onCustomEvent(CustomEvent e) {
		/*if (e.getCondition().getName().equals("too_close_to_walls"))
		{
			setTurnLeft(30);
			setAhead(-40);
			waitFor(new TurnCompleteCondition(this));
			
		}*/
	}


 }

class Robot
{
	private long last_seen;
	private double x,y,heading,gun_direction,hp;
	private String name;
	private double follow_blocked=-10;		// we have decided not to follow this at time saved in this
	public void SetX(double x_){ x=x_;}
	public void SetY(double y_){ y=y_;}
	public double GetX(){ return x;}
	public double GetY(){ return y; }
	public double GetHeading(){ return heading; }
	public String GetName() { return name; }
	public void SetName(String n) { name=n; }
	public void SetTime(long time){ last_seen = time; }
	public long GetTime(){ return last_seen; }
	public double GetHP() { return hp; }
	public void SetHP(double hp_){ hp=hp_;}
	
	public double FollowBlocked(){ return follow_blocked; }
	public void SetFollowBlocked(double time){ follow_blocked = time; }
	public void RemoveFollowBlocked(){ follow_blocked=-10; }
}
